

package PresentationLayers;

import BusinessLogicLayers.ShowDiaLogBLL;
import DataAccessLayers.clsDatabase;
import java.awt.Graphics;
import java.net.InetAddress;
import java.sql.ResultSet;
import java.sql.Statement;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;


public class FrmConnect extends javax.swing.JPanel {

    private FrmMain frm;
    private ShowDiaLogBLL dialog;
    public FrmConnect(FrmMain frm,ShowDiaLogBLL dialog) {
        initComponents();
        this.frm=frm;
        this.dialog=dialog;
        JOptionPane.showMessageDialog(frm, "Kết Nối Cơ Sở Dữ Liệu Thất Bại");
        try {
                InetAddress addr=InetAddress.getLocalHost();
                String hostname = addr.getHostName();
                txtservername.setText(hostname+"\\SQLEXPRESS");
            } catch (Exception e) {
            }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel(){
            public void paintComponent(Graphics g){

                ImageIcon icon=new ImageIcon(getClass().getResource("/PresentationLayers/Images/nav.png"));

                g.drawImage(icon.getImage(),0 , 0, this.getWidth(), this.getHeight(), null);
                setOpaque(false);
                super.paintComponent(g);
            }

        };
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        cbbauthentication = new javax.swing.JComboBox();
        txtservername = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        txtusername = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        txtpassword = new javax.swing.JPasswordField();
        jLabel6 = new javax.swing.JLabel();
        cbbdatabase = new javax.swing.JComboBox();
        btnconnect = new javax.swing.JButton();
        btncancel = new javax.swing.JButton();
        btntestconnect = new javax.swing.JButton();

        jLabel1.setFont(new java.awt.Font("Trebuchet MS", 0, 11)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(0, 102, 255));
        jLabel1.setText("Server Name:");

        jLabel2.setFont(new java.awt.Font("Trebuchet MS", 0, 11)); // NOI18N
        jLabel2.setForeground(new java.awt.Color(0, 102, 255));
        jLabel2.setText("Authentication:");

        cbbauthentication.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Windows Authentication", "SQL Server Authentication" }));
        cbbauthentication.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbbauthenticationActionPerformed(evt);
            }
        });

        jLabel3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/PresentationLayers/Images/connection.png"))); // NOI18N

        jLabel4.setFont(new java.awt.Font("Trebuchet MS", 0, 11)); // NOI18N
        jLabel4.setForeground(new java.awt.Color(0, 102, 255));
        jLabel4.setText("Username:");

        txtusername.setEnabled(false);

        jLabel5.setFont(new java.awt.Font("Trebuchet MS", 0, 11)); // NOI18N
        jLabel5.setForeground(new java.awt.Color(0, 102, 255));
        jLabel5.setText("Password:");

        txtpassword.setEnabled(false);

        jLabel6.setFont(new java.awt.Font("Trebuchet MS", 0, 11)); // NOI18N
        jLabel6.setForeground(new java.awt.Color(0, 102, 255));
        jLabel6.setText("Database:");

        cbbdatabase.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                cbbdatabaseMouseClicked(evt);
            }
        });

        btnconnect.setText("Connect");
        btnconnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnconnectActionPerformed(evt);
            }
        });

        btncancel.setText("Cancel");
        btncancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btncancelActionPerformed(evt);
            }
        });

        btntestconnect.setText("Test Connect");
        btntestconnect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btntestconnectActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel3)
                .addGap(28, 28, 28)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel5)
                    .addComponent(jLabel4)
                    .addComponent(jLabel6)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(cbbdatabase, javax.swing.GroupLayout.PREFERRED_SIZE, 184, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(btnconnect, javax.swing.GroupLayout.PREFERRED_SIZE, 86, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btncancel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(txtservername)
                            .addComponent(cbbauthentication, 0, 184, Short.MAX_VALUE)
                            .addComponent(btntestconnect, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(txtusername)
                            .addComponent(txtpassword))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(23, 23, 23)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtservername, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel1))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(cbbauthentication, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel2))
                        .addGap(13, 13, 13)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtusername, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel4))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtpassword, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel5))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btntestconnect)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(cbbdatabase, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel6)))
                    .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(24, 24, 24)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnconnect)
                    .addComponent(btncancel))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    private void cbbauthenticationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbbauthenticationActionPerformed
        if(cbbauthentication.getSelectedIndex()==0)
        {
            txtpassword.setEnabled(false);
            txtusername.setEnabled(false);
        }
        else
        {
            txtpassword.setEnabled(true);
            txtusername.setEnabled(true);
        }
    }//GEN-LAST:event_cbbauthenticationActionPerformed
    private clsDatabase con=null;
    private void cbbdatabaseMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cbbdatabaseMouseClicked
        try {
            if(cbbauthentication.getSelectedIndex()==1)
            con=new clsDatabase(txtservername.getText(),"master",txtusername.getText(),new String(txtpassword.getPassword()));
            else
            con=new clsDatabase(txtservername.getText(),"master");
            AddListDataBase();
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Kết Nối Thất Bại");
        }
    }//GEN-LAST:event_cbbdatabaseMouseClicked

    private void btnconnectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnconnectActionPerformed

        try {
            if(cbbdatabase.getItemCount()==0)
            JOptionPane.showMessageDialog(null, "Hãy Chọn 1 Database");
            else
            {
                if(cbbauthentication.getSelectedIndex()==1)
                con=new clsDatabase(txtservername.getText(),String.valueOf(cbbdatabase.getSelectedItem()),txtusername.getText(),new String(txtpassword.getPassword()));
                else
                con=new clsDatabase(txtservername.getText(),String.valueOf(cbbdatabase.getSelectedItem()));
                dialog.Hidden();
                JOptionPane.showMessageDialog(null, "Kết Nối Thành Công");
                frm.iconlogin(true);
                frm.IconKetNoi(false);
                frm.connectdb(con);
            }
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Kết Nối Thất Bại "+e.getMessage());
        }
    }//GEN-LAST:event_btnconnectActionPerformed

    private void btncancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btncancelActionPerformed
        dialog.Hidden();
    }//GEN-LAST:event_btncancelActionPerformed

    private void btntestconnectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btntestconnectActionPerformed
        try {
            if(cbbauthentication.getSelectedIndex()==1)
            con=new clsDatabase(txtservername.getText(),"master",txtusername.getText(),new String(txtpassword.getPassword()));
            else
            con=new clsDatabase(txtservername.getText(),"master");
            AddListDataBase();
            JOptionPane.showMessageDialog(null, "Kết Nối Thành Công");
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Kết Nối Thất Bại");
        }
    }//GEN-LAST:event_btntestconnectActionPerformed
    private void AddListDataBase()
      {
          cbbdatabase.removeAllItems();
          try {
              ResultSet rss=select("SELECT name FROM sys.databases WHERE name not in('master','model','msdb','tempdb')");
            while(rss.next())
            {
                cbbdatabase.addItem(rss.getString(1));
            }
          } catch (Exception e) {
          }
            
      }
    //select dữ liệu trong database
    public ResultSet select(String query)
    {
        try
        {
            Statement stm;
            stm = con.getConnect().createStatement();
            ResultSet rss = stm.executeQuery(query);
            return rss;
        }
        catch(Exception ex)
        {
            JOptionPane.showMessageDialog(null, ex.getMessage());
        }
        return null;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btncancel;
    private javax.swing.JButton btnconnect;
    private javax.swing.JButton btntestconnect;
    private javax.swing.JComboBox cbbauthentication;
    private javax.swing.JComboBox cbbdatabase;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPasswordField txtpassword;
    private javax.swing.JTextField txtservername;
    private javax.swing.JTextField txtusername;
    // End of variables declaration//GEN-END:variables
}
